SystemOrganization addCategory: #GroupManager!

Object subclass: #AbstractGroup
	instanceVariableNames: 'name readOnly removable sortBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!AbstractGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/18/2011 14:06'!
named: aString

	^ self new name: aString! !

!AbstractGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/21/2011 15:32'!
new

	| instance |
	instance := self basicNew initialize.
	GroupsManager register: instance.
	^ instance! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:00'!
beReadOnly

	readOnly := true! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:22'!
elements

	^ self subclassResponsibility! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 16:57'!
ifAllowed: aBlock

	^ self ifAllowed: aBlock ifNot: []! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 16:57'!
ifAllowed: aBlock ifNot: anotherBlock

	^ self isReadOnly
		ifTrue: anotherBlock
		ifFalse: aBlock! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:01'!
initialize

	super initialize.
	readOnly := false! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:00'!
isReadOnly

	^ readOnly == true! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:03'!
name

	^ name! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:04'!
name: aString

	self ifAllowed: [ name := aString ]! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/24/2011 13:41'!
removable

	^ removable ifNil: [ removable := true ]! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/24/2011 13:39'!
removable: aBoolean

	removable := aBoolean! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 13:20'!
sortBlock

	^ sortBlock ifNil: [ sortBlock := [:a :b | a printString <= b printString ]]! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 13:16'!
sortBlock: aBlock

	sortBlock := aBlock! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/21/2011 15:32'!
unregister

	GroupsManager unregister: self! !

AbstractGroup subclass: #DynamicGroup
	instanceVariableNames: 'model selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!DynamicGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/18/2011 15:38'!
named: aString model: aClass selector: aSelector

	^ self basicNew
			name: aString;
			model: aClass;
			selector: aSelector;
			initialize;
			yourself! !

!DynamicGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/24/2011 13:22'!
named: aString model: aClass selector: aSelector sortBlock: aBlock

	^ self basicNew
			name: aString;
			model: aClass;
			selector: aSelector;
			sortBlock: aBlock;
			initialize;
			yourself! !

!DynamicGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/24/2011 13:52'!
elements

	^ (self model perform: self selector) copy! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 13:32'!
initialize

	super initialize.
	readOnly := true.! !

!DynamicGroup methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 3/22/2011 17:06'!
isFillable

	^ false! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:23'!
model

	^ model! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:39'!
model: anObject

	self ifAllowed: [	model := anObject ]! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:23'!
selector

	^ selector! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:39'!
selector: anObject

	self ifAllowed: [	selector := anObject ]! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 13:14'!
sortBlock: aBlock

	sortBlock := aBlock! !

AbstractGroup subclass: #StaticGroup
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!StaticGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/18/2011 14:29'!
named: aString with: aCollection

	^ (super named: aString) with: aCollection! !

!StaticGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:05'!
add: anElement

	^ self ifAllowed: [ elements add: anElement ]! !

!StaticGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:22'!
elements

	^ elements copy! !

!StaticGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:01'!
initialize

	super initialize.
	readOnly := false! !

!StaticGroup methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 3/22/2011 17:06'!
isFillable

	^ true! !

!StaticGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:05'!
remove: anElement

	^ self ifAllowed: [ elements remove: anElement ]! !

!StaticGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:30'!
with: aCollection

	self ifAllowed: [ elements := aCollection ]! !

Object subclass: #GroupsHolder
	instanceVariableNames: 'groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!GroupsHolder methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 3/18/2011 16:56'!
add: anElement into: aGroup

	aGroup
		ifAllowed: [ aGroup add: anElement ]
		ifNot: [ self openReadOnlyError ]! !

!GroupsHolder methodsFor: 'dynamic group' stamp: 'BenjaminVanRyseghem 3/24/2011 13:32'!
addADynamicGroupSilentlyNamed: entry model: aClass selector: aSelector

	(self includesAGroupNamed: entry)
		ifTrue: [ 
			self openError.
			^ nil]
		ifFalse: [ 
			^ self groups
				add: 
					(DynamicGroup 
						named: entry 
						model: aClass 
						selector: aSelector)]! !

!GroupsHolder methodsFor: 'dynamic group' stamp: 'BenjaminVanRyseghem 3/24/2011 13:32'!
addADynamicGroupSilentlyNamed: entry model: aClass selector: aSelector sortBlock: aBlock

	(self includesAGroupNamed: entry)
		ifTrue: [ 
			self openError.
			^ nil]
		ifFalse: [ 
			^ self groups 
				add: 
					(DynamicGroup
						named: entry 
						model: aClass 
						selector: aSelector
						sortBlock: aBlock)]! !

!GroupsHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/18/2011 14:26'!
addAGroup

self halt! !

!GroupsHolder methodsFor: 'static group' stamp: 'BenjaminVanRyseghem 3/18/2011 14:37'!
addAStaticGroupSilentlyNamed: entry with: aCollection

	(self includesAGroupNamed: entry)
		ifTrue: [ 
			self openError.
			^ nil]
		ifFalse: [ 
			^ self groups add: (StaticGroup named: entry with: aCollection)]! !

!GroupsHolder methodsFor: 'static group' stamp: 'BenjaminVanRyseghem 3/18/2011 14:26'!
addAnEmptyStaticGroupSilentlyNamed: entry

	^ self addAStaticGroupSilentlyNamed: entry with: OrderedCollection new! !

!GroupsHolder methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 3/21/2011 15:26'!
createADynamicGroup

	| entry aClass aSelector |
	entry := UIManager default textEntry: 'Name of the new group:' title: 'Create a new group' entryText: 'MyNewGroupName'.
	aClass := nil.
	aSelector := nil.
	^ entry ifNotNil: [ self addADynamicGroupSilentlyNamed: entry model: aClass selector: aSelector ].! !

!GroupsHolder methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 3/22/2011 17:04'!
createAnEmptyStaticGroup

	| entry |
	entry := UIManager default request: 'Name of the new group:' initialAnswer: '' title: 'Create a new group'.
	^ (entry isNil or: [entry isEmpty])
		ifFalse: [ self addAnEmptyStaticGroupSilentlyNamed: entry ]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:40'!
groupNamed: aString

	^ self groups detect: [:each | each name = aString]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 15:04'!
groups

	^  groups ifNil: [ groups := OrderedCollection new ]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:32'!
groupsNames

	^ self groups collect: [:group | group name ]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:37'!
includesAGroupNamed: aName

	^ self groupsNames includes: aName! !

!GroupsHolder methodsFor: 'windows' stamp: 'BenjaminVanRyseghem 3/22/2011 18:14'!
openError

	UIManager default alert: 'This group already exists' title: 'Already exists'! !

!GroupsHolder methodsFor: 'windows' stamp: 'BenjaminVanRyseghem 3/22/2011 18:14'!
openReadOnlyError

	UIManager default  alert: 'This group is read only' title: 'Access error'! !

!GroupsHolder methodsFor: 'windows' stamp: 'BenjaminVanRyseghem 3/22/2011 18:15'!
openRemoveDialogOn: aGroup

	^UIManager default confirm: ('Dou you really want to delete the group named ', aGroup name)! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 16:58'!
remove: aClass from: aGroup

	^ aGroup
		ifAllowed: [ aGroup remove: aClass ]
		ifNot: [ self openReadOnlyError ]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/24/2011 13:49'!
removeAGroup: aGroup

	| yesIWantToRemoveTheGroup |
	yesIWantToRemoveTheGroup := self openRemoveDialogOn: aGroup.
	(yesIWantToRemoveTheGroup not)
		ifTrue: [ ^ self ].
	 aGroup removable
		ifFalse: [ ^ self openReadOnlyError ].
	^ groups remove: aGroup.
! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 16:03'!
renameAGroup: aGroup

	| entry |
	entry := UIManager default request: 'Name of the new group' initialAnswer: '' title: 'Create a new group'.
	(entry isNil or: [entry isEmpty]) ifTrue: [^ aGroup].
	(self includesAGroupNamed: entry)
		ifTrue: [ ^ self openError ].
	aGroup isReadOnly
		ifTrue: [ ^ self openReadOnlyError ].
	aGroup name: entry.
	^ aGroup	
! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:54'!
sort: aBlock

	^ groups := self groups sort: aBlock! !

Object subclass: #GroupsManager
	instanceVariableNames: 'groups'
	classVariableNames: 'CurrentManager'
	poolDictionaries: ''
	category: 'GroupManager'!

!GroupsManager class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/21/2011 16:08'!
current

	^ CurrentManager ifNil: [ CurrentManager := self new ]! !

!GroupsManager class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/21/2011 16:09'!
register: aGroup

	self current register: aGroup! !

!GroupsManager class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/21/2011 16:08'!
setCurrentManager: aManager

	CurrentManager := aManager! !

!GroupsManager class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/21/2011 16:09'!
unregister: aGroup

	self current unregister: aGroup! !

!GroupsManager methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/21/2011 16:11'!
initialize

	super initialize.
	groups := OrderedCollection new! !

!GroupsManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/21/2011 16:11'!
register: aGroup

	groups add: aGroup! !

!GroupsManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/21/2011 16:11'!
unregister: aGroup

	groups remove: aGroup! !
